;DEFINICIN DE FUNCIN PARA LEER ARCHIVOS
;ARGUMENTO: NOMBRE DEL ARCHIVO A ABRIR
;DEVUELVE UNA LISTA DONDE CADA ELEMENTO ES UNA LISTA QUE CONTIENE CADA UNA DE LAS LNEAS DEL ARCHIVO ABIERTO
(defun lista (archivo / id-archivo tmp)
  (if (setq id-archivo (open (findfile archivo) "r"))
    (while (setq linea (read-line id-archivo))
      (setq tmp (cons (read (strcat "(" linea ")")) tmp)))
    )
    (close id-archivo)
  (reverse tmp)
    )

;DEFINICIN DE FUNCIN PARA GUARDAR UN ARCHIVO
(defun lista->csv  (lista delim archivo anexar / id-archivo)
  (if (setq id-archivo (open archivo (if anexar "a" "w")))
    (progn (foreach sublista  lista
             (while (setq valor (car sublista))
               (prin1 valor id-archivo)
               (if (setq sublista (cdr sublista))
                 (princ delim id-archivo)))
             (write-char 10 id-archivo))
           (close id-archivo))))


;DEFINICIN DE FUNCIN DE CONFIGURACIN
;DEVUELVE LA VARIABLE ESCALA (NMERO REAL MAYOR QUE 0)
(defun configuracion ()
(setq escala (getreal "\nIngrese altura de los textos o nada para indicar desde pantalla:" ) )
(if (= escala nil) (setq escala 0)
(if (< escala 0) (setq escala 0))  
  ))



;DEFINICIN DE FUNCION SALIDA (4 DECIMALES Y LONGITUD MAX LONG)
(DEFUN SALIDA (DATO LONG / L)
( IF (< LONG 5) (SETQ LONG 5))
(SETQ L (STRLEN (RTOS (ABS DATO) 2 0)))
(IF (> L LONG)
       (RTOS DATO 1 (- LONG 5))
       (RTOS DATO 2 (if (< (- long L) 4) (- long L) 4))
  ))


;DEFINICION DE LA FUNCION DE BUSQUEDA DE BLOQUES
(DEFUN BUSQUEDA ( / U)
  (IF (= UB1 NIL)
                  (if (FINDFILE "PGEO.CFG") (SETQ UB1 (CAR (CAR (LISTA (FINDFILE "PGEO.CFG")))))))
  (if (= UB1 NIL) (setq ub1 (findfile "pgeo-o.dwg")))
       
  (IF (= UB1 NIL)
(PROGN
     (SETQ U (FINDFILE "ACAD.EXE")) 
     (SETQ U (VL-STRING-SUBST "PGEO.CFG" "ACAD.EXE" U))
  
     (SETQ UB1 (GETFILED "INDIQUE LA UBICACION DEL ARCHIVO PGEO-O" "pgeo-O" "dwg" 8))
     (lista->csv  (LIST (LIST UB1)) " " U NIL) 
     ))
  
  (IF (= UB2 NIL)
   (if (FINDFILE "PGEO.CFG") (SETQ UB2 (CAR (CAR (CDR (LISTA (FINDFILE "PGEO.CFG"))))))))

  (if (= UB2 NIL) (setq ub2 (findfile "pgeo-t.dwg")))
  
   (IF (= UB2 NIL)
  (PROGN   
  (SETQ UB2 (GETFILED "INDIQUE LA UBICACION DEL ARCHIVO PGEO-T" "pgeo-T" "dwg" 8))
     (lista->csv  (LIST (LIST UB2)) " " U 1)
  )))


;DEFINICIN DE FUNCIN CLCULO
(DEFUN CALCULO (/ o a obj p area x y jx jy jxy jxg jyg jxyg ji jii ri rii alfa alfa2 osn)
  
(setq o (getpoint "\nIngrese el origen del sistema de coordenadas: ")) ;CAMBIO DEL SISTEMA DE COORDENADAS
( IF O () (SETQ O (LIST 0 0 0)))
 (command "_ucs" "n" o)

(while (= obj nil)                              ;ELECCION DE LA REGION
(setq obj (entsel "\nSeleccione regin:")))

  
(command "_massprop" obj "" "Y" "solido.mpr")    ;GENERACIN DEL ARCHIVO CON LAS PROPIEDADES CALCULADAS POR AUTOCAD

(setq p (lista "solido.MPR"))                     ;LECTURA DEL ARCHIVO
(vl-file-delete (findfile "solido.mpr"))          ;ELIMINACION DEL ARCHIVO
(setq area (car (cdr (nth 3 p))))               ;GUARDADO DE LOS CLCULOS EN VARIABLES
(setq x (car (cdr (cdr (nth 7 p)))))
(setq y (car (cdr (nth 8 p))))
(setq jx (car (cdr (cdr (cdr (cdr (nth 9 p)))))))
(setq jy (car (cdr (nth 10 p))))
(setq jxy (car (cdr (cdr (cdr (cdr (nth 11 p)))))))
  
(setq jxg (- jx (* y y area)))                  ;CALCULO DE LAS CARACTERISTICAS BARICENTRICAS 
(setq jyg (- jy (* x x area)))
(setq jxyg (- jxy (* y x area)))
(setq JI ( * 0.5 ( + (+ JXG JYG) (SQRT (+ (* (- JXG JYG) (- JXG JYG)) (* 4 JXYG JXYG))))))
(setq JII ( * 0.5 ( - (+ JXG JYG) (SQRT (+ (* (- JXG JYG) (- JXG JYG)) (* 4 JXYG JXYG))))))
(setq ri (sqrt (/ ji area)))
(setq rii (sqrt (/ jii area)))
  
(if (= (rtos (abs (/ jxg jyg)) 2 3 ) "1.000")
(PROGN
(if (= (rtos (abs (/ ji jii)) 2 3 ) "1.000")
(setq alfa 0)
(setq alfa 45)))
(setq alfa (* (/ 180 pi) 0.5 (atan ( * 2 (/ jxyg ( - jyg jxg)))))))

(IF (<
(atof (rtos
  (/ (+ (* 0.5 (+ JXG JYG)) ( * 0.5 (COS (/ (* 2 ALFA PI) 180) ) (- JXG JYG)) (* JXYG -1 (SIN (/ (* 2 ALFA PI) 180)) ))
  (+ (* 0.5 (+ JXG JYG)) ( * 0.5 (COS (/ (* 2 (+ ALFA 90) PI) 180) ) (- JXG JYG)) (* JXYG -1 (SIN (/ (* 2 (+ ALFA 90) PI) 180)) ) ))
  2 3)) 1
  )
(IF (> ALFA 0) (setq alfa (- ALFA 90)) (setq alfa (+ ALFA 90)))
  ()
 )
(SETQ ALFA2 (+ ALFA 90))

(setq o (getpoint "\nIngrese el punto de aplicacin de la tabla de resultados: "))
( IF O () (SETQ O (LIST 0 0 0)))
(if (= escala 0) (PROGN
(setq a (getcorner "\nIngrese punto inferior de la tabla de resultados: " o))
(setq escala (abs (/ (- (car (cdr a)) (car (cdr o))) 15 )))))
                  
(setq osn (getvar "osmode"))    ;CONTROL DE LOS PUNTOS DE APLICACIN
(setvar "osmode" 0)


(vl-cmdf "insert" UB1 "0,0,0" ESCALA ESCALA 0 "X" "Y" "o")
(vl-cmdf "insert" UB1 (list x y 0) ESCALA ESCALA alfa "I" "II" "G")  
  
(SETQ X (SALIDA X LONG))
(SETQ Y (SALIDA Y LONG))
(SETQ AREA (SALIDA AREA LONG))
(SETQ JX (SALIDA JX LONG))
(SETQ JY (SALIDA JY LONG))
(SETQ JXY (SALIDA JXY LONG))
(SETQ JXG (SALIDA JXG LONG))
(SETQ JYG (SALIDA JYG LONG))
(SETQ JXYG (SALIDA JXYG LONG))
(SETQ JI (SALIDA JI LONG))
(SETQ JII (SALIDA JII LONG))
(SETQ ALFA (rtos ALFA 2 2))
(SETQ ALFA2 (rtos ALFA2 2 2))
(SETQ RI (SALIDA RI LONG))
(SETQ RII (SALIDA RII LONG))
  
  
(vl-cmdf "insert" UB2 o ESCALA ESCALA 0 x y area jx jy jxy jxg jyg jxyg ji jii Alfa alfa2 ri rii)


(setvar "osmode" OSN)   ;RETORNO DEL OSNAP
(command "_ucs" "p")    ;RETORNO DEL SISTEMA DE COORDENADAS
  )




;DEFINICIN DEL CUERPO PRINCIPAL DEL PROGRAMA

(DEFUN C:PGEO ( / pr ch Z)
(setq pr (getvar "luprec"))    ;CONTROL DE LA PRESICION EN LOS CALCULOS
(setvar "luprec" 8)
(setq ch (getvar "cmdecho"))   ;CONTROL DE LA PANTALLA
(setvar "cmdecho" 0)  
(setq Z (getvar "dimzin"))     ;CONTROL DE LA SUPRESION DE CEROS
(setvar "dimzin" 0)
(setQ LONG 9)
(if (= escala nil) (setq escala 2))
(BUSQUEDA)
(CONFIGURACION)
(CALCULO)
  
(setvar "luprec" PR)           ;RETONO DE LA PRESICION DEL USUARIO
(setvar "cmdecho" ch)          ;RETONO DE LA CONFIGURACION DE PANTALLA
(setvar "dimzin" Z)            ;RETONO DE LA CONFIGURACION DE SUPRESION DE CEROS
  )